import numpy as np
import matplotlib.pyplot as plt
import time

import gravity
#import gravity_cy as gravity

def compute_orbit(planet):
    N = 1000

    positions = np.zeros((N, 3))

    for j in range(N):
        gravity.step_time(planet, time_span=0.01, n_steps=500)
        positions[j,:] = planet.x, planet.y, planet.z

    return positions

def main():
    planet = gravity.Planet()

    start = time.time()
    positions = compute_orbit(planet)
    print "Took:", time.time() - start

    plt.plot(positions[:,0], positions[:,1], '-')
    plt.plot([0], [0], 'y*', ms=20)
    plt.axis('equal')
    plt.show()

if __name__ == "__main__":
    main()
