/*
    Anagrammimylly: an anagram generator
    Copyright (C) 1998-2000 Pauli Virtanen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/*
 * Internal header: contains the real functions.
 */
#ifndef ANAGRAM_INTERNAL_H
#define ANAGRAM_INTERNAL_H

#include <ctype.h>

#include "wordlist.h"
#include "anagram.h"

#ifdef __cplusplus
extern "C" {
#endif

        /*
         * Helper function
         */
        static void str_tolower(char *s)
        {
                if (s == NULL) return;
                for (; *s != '\0'; ++s)
                    *s = tolower(*s);
        }

        
        /*
         * The complex interface, do not use
         */
        success_t find_anagrams(char *word, char *must_have,
                                wordlist_t *lex, outfunc_t *tolist,
                                outfunc_t *toinfo, void *user_data);

        success_t wl_add_file(char *file, wordlist_t *lex, outfunc_t *outinfo,
                              void *user_data);
        unsigned long wl_fix(wordlist_t *lex, outfunc_t *outinfo,
                             void *user_data,
                             char dup, char low, char one, char two,char sort,
                             char remlong);

#ifdef __cplusplus
}
#endif
#endif
